package fastly

import "testing"

func TestClient_BlobStorages(t *testing.T) {
}

func TestClient_ListBlobStorages_validation(t *testing.T) {
	var err error
	_, err = testClient.ListBlobStorages(&ListBlobStoragesInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.ListBlobStorages(&ListBlobStoragesInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_CreateBlobStorage_validation(t *testing.T) {
	var err error
	_, err = testClient.CreateBlobStorage(&CreateBlobStorageInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.CreateBlobStorage(&CreateBlobStorageInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_GetBlobStorage_validation(t *testing.T) {
	var err error
	_, err = testClient.GetBlobStorage(&GetBlobStorageInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetBlobStorage(&GetBlobStorageInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetBlobStorage(&GetBlobStorageInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_UpdateBlobStorage_validation(t *testing.T) {
	var err error
	_, err = testClient.UpdateBlobStorage(&UpdateBlobStorageInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateBlobStorage(&UpdateBlobStorageInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateBlobStorage(&UpdateBlobStorageInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_DeleteBlobStorage_validation(t *testing.T) {
	var err error
	err = testClient.DeleteBlobStorage(&DeleteBlobStorageInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteBlobStorage(&DeleteBlobStorageInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteBlobStorage(&DeleteBlobStorageInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}
