package fastly

import "testing"

func TestClient_DictionaryItems(t *testing.T) {
}

func TestClient_ListDictionaryItems_validation(t *testing.T) {
	var err error
	_, err = testClient.ListDictionaryItems(&ListDictionaryItemsInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.ListDictionaryItems(&ListDictionaryItemsInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_CreateDictionaryItem_validation(t *testing.T) {
	var err error
	_, err = testClient.CreateDictionaryItem(&CreateDictionaryItemInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.CreateDictionaryItem(&CreateDictionaryItemInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_GetDictionaryItem_validation(t *testing.T) {
	var err error
	_, err = testClient.GetDictionaryItem(&GetDictionaryItemInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetDictionaryItem(&GetDictionaryItemInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetDictionaryItem(&GetDictionaryItemInput{
		Service:    "foo",
		Dictionary: "test",
		ItemKey:    "",
	})
	if err != ErrMissingItemKey {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_UpdateDictionaryItem_validation(t *testing.T) {
	var err error
	_, err = testClient.UpdateDictionaryItem(&UpdateDictionaryItemInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateDictionaryItem(&UpdateDictionaryItemInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateDictionaryItem(&UpdateDictionaryItemInput{
		Service:    "foo",
		Dictionary: "test",
		ItemKey:    "",
	})
	if err != ErrMissingItemKey {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_DeleteDictionaryItem_validation(t *testing.T) {
	var err error
	err = testClient.DeleteDictionaryItem(&DeleteDictionaryItemInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteDictionaryItem(&DeleteDictionaryItemInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteDictionaryItem(&DeleteDictionaryItemInput{
		Service:    "foo",
		Dictionary: "test",
		ItemKey:    "",
	})
	if err != ErrMissingItemKey {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_BatchModifyDictionaryItem_validation(t *testing.T) {
	var err error
	err = testClient.BatchModifyDictionaryItems(&BatchModifyDictionaryItemsInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}
	err = testClient.BatchModifyDictionaryItems(&BatchModifyDictionaryItemsInput{
		Service:    "foo",
		Dictionary: "",
	})
	if err != ErrMissingDictionary {
		t.Errorf("bad error: %s", err)
	}

	oversizedDictionaryItems := make([]*BatchDictionaryItem, BatchModifyMaximumOperations+1)
	err = testClient.BatchModifyDictionaryItems(&BatchModifyDictionaryItemsInput{
		Service:    "foo",
		Dictionary: "bar",
		Items:      oversizedDictionaryItems,
	})
	if err != ErrBatchUpdateMaximumOperationsExceeded {
		t.Errorf("bad error: %s", err)
	}

}
