package fastly

import "testing"

func TestClient_DirectorBackends(t *testing.T) {
}

func TestClient_CreateDirectorBackend_validation(t *testing.T) {
	var err error
	_, err = testClient.CreateDirectorBackend(&CreateDirectorBackendInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.CreateDirectorBackend(&CreateDirectorBackendInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_GetDirectorBackend_validation(t *testing.T) {
	var err error
	_, err = testClient.GetDirectorBackend(&GetDirectorBackendInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetDirectorBackend(&GetDirectorBackendInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetDirectorBackend(&GetDirectorBackendInput{
		Service:  "foo",
		Version:  1,
		Director: "",
	})
	if err != ErrMissingDirector {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetDirectorBackend(&GetDirectorBackendInput{
		Service:  "foo",
		Version:  1,
		Director: "director",
		Backend:  "",
	})
	if err != ErrMissingBackend {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_DeleteDirectorBackend_validation(t *testing.T) {
	var err error
	err = testClient.DeleteDirectorBackend(&DeleteDirectorBackendInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteDirectorBackend(&DeleteDirectorBackendInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteDirectorBackend(&DeleteDirectorBackendInput{
		Service:  "foo",
		Version:  1,
		Director: "",
	})
	if err != ErrMissingDirector {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteDirectorBackend(&DeleteDirectorBackendInput{
		Service:  "foo",
		Version:  1,
		Director: "director",
		Backend:  "",
	})
	if err != ErrMissingBackend {
		t.Errorf("bad error: %s", err)
	}
}
