package fastly

import "testing"

func TestClient_RequestSettings(t *testing.T) {
}

func TestClient_ListRequestSettings_validation(t *testing.T) {
	var err error
	_, err = testClient.ListRequestSettings(&ListRequestSettingsInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.ListRequestSettings(&ListRequestSettingsInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_CreateRequestSetting_validation(t *testing.T) {
	var err error
	_, err = testClient.CreateRequestSetting(&CreateRequestSettingInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.CreateRequestSetting(&CreateRequestSettingInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_GetRequestSetting_validation(t *testing.T) {
	var err error
	_, err = testClient.GetRequestSetting(&GetRequestSettingInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetRequestSetting(&GetRequestSettingInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.GetRequestSetting(&GetRequestSettingInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_UpdateRequestSetting_validation(t *testing.T) {
	var err error
	_, err = testClient.UpdateRequestSetting(&UpdateRequestSettingInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateRequestSetting(&UpdateRequestSettingInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	_, err = testClient.UpdateRequestSetting(&UpdateRequestSettingInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}

func TestClient_DeleteRequestSetting_validation(t *testing.T) {
	var err error
	err = testClient.DeleteRequestSetting(&DeleteRequestSettingInput{
		Service: "",
	})
	if err != ErrMissingService {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteRequestSetting(&DeleteRequestSettingInput{
		Service: "foo",
		Version: 0,
	})
	if err != ErrMissingVersion {
		t.Errorf("bad error: %s", err)
	}

	err = testClient.DeleteRequestSetting(&DeleteRequestSettingInput{
		Service: "foo",
		Version: 1,
		Name:    "",
	})
	if err != ErrMissingName {
		t.Errorf("bad error: %s", err)
	}
}
